<?php
header("Content-type:text/html; charset='utf-8'");

/*
Plugin Name: cleanUpload
Description: Удаляет неиспользуемые в контенте файлы из upload
Version: 0.9.0
Author: BATPYIIIKOB
Author URI: http://www.BATPYIIIKOB.ru/
*/

spl_autoload_register(function ($class) {
    include 'cleanUpload/' . $class . '.php';
});

# получение корректного идентификатора плагина
$thisfile = basename(__FILE__, ".php");

# add in this plugin's language file
i18n_merge($thisfile) || i18n_merge($thisfile, 'en_US');

# регистрируем плагин в системе
register_plugin(
    $thisfile, //идентификатор плагина
    i18n_r($thisfile.'/CLEAN_TITLE'), //Название плагина
    '0.9.0', 		//Версия плагина
    'BATPYIIIKOB',  //автор плагина
    'http://www.BATPYIIIKOB.ru/', //сайт автора
    'Удаляет неиспользуемые в контенте файлы из upload', //краткое описание плагина
    'files', //тип страницы – на какой из вкладок административной панели появится плагин
    'clean_upload'  //главная функция плагина (функция администрирования)
);

# activate filter/активируем фильтр
add_action('files-content','clean_upload');

# Добавляем ссылку на вкладку Темы
add_action('files-sidebar','createSideMenu',array($thisfile,i18n_r("cleanUpload/CLEAN_TITLE")));

# Вывод результата на экран
function PrePrintArray($arr){
    echo '<br><pre><b>'.i18n_r("cleanUpload/FILES_NOT_USE").count($arr).'</b><br><br>';
    foreach ($arr as &$filename) {
        echo "<b>$filename</b><br>";
    }
    echo '</pre><br>';
}

# Удалить найденные файлы
function deleteResult($arr){
   echo '<br><pre><b>'.i18n_r("cleanUpload/FILES_DELETED").'</b><br><br>';
   foreach ($arr as &$filename) {
        unlink("../".$filename);
        echo "<b>$filename -" .i18n_r("cleanUpload/DELETED")."</b><br>";
   }
   echo '</pre><br>';
}

# Теперь – функции плагина
function clean_upload() {
    $DATA_GALLERY_PATH = '../data/i18n_gallery/';
    $DATA_UPLOAD_PATH = '../data/uploads';
    $DATA_PAGES_PATH = '../data/pages/';

    i18n("cleanUpload/DESCRIPTION");

    echo "<br><br><form method='POST'>";
    echo "<input type='submit' class='submit' name='find-files' value=".i18n_r("cleanUpload/BTN_FIND").">";
    echo "</form><hr>";


    if (isset($_POST['find-files']) or isset($_POST['delete-result'])) {

        # Анализ страниц ../data/pages/
        $links = new PageAnalize();
        $links_arr = $links ->PageAnalizeContent($DATA_PAGES_PATH);

        # Анализ фотоальбомов ../data/i18n_gallery/
        $links_gallery = new GalleryAnalize();
        $links_gallery_arr  = $links_gallery -> PageAnalizeGallery($DATA_GALLERY_PATH);

        # Анализ директории с файлами ../data/uploads
        $upfiles = new UploadAnalize();
        $upfiles_arr = $upfiles -> ListFilesDirectory($DATA_UPLOAD_PATH);

        # из всех ссылок на файлы в Upload удаляем ссылки которые используются в контенте и галлереи
        $diff_arr = array_diff($upfiles_arr,$links_arr,$links_gallery_arr);

        # если нажали кнопку "Удалить всё"
        if (isset($_POST['delete-result'])){
            deleteResult($diff_arr);
        }else{
            if (!empty($diff_arr)) {
                PrePrintArray($diff_arr);
                echo "<br><hr>";
                i18n("cleanUpload/RECOMENDATION_CLEAN");
                echo "<br><br><form method='POST'>";
                echo "<input type='submit' class='submit' name='delete-result' value=".i18n_r("cleanUpload/BTN_DEL").">";
                echo "</form>";
            }
            else{
                i18n("cleanUpload/FILES_NOT_CLEAN");
            }
        }
    }
}

?>